## pydantic 2.12.3

=== Makefile ===
.DEFAULT_GOAL := all
sources = pydantic tests docs/plugins release/
NUM_THREADS?=1

.PHONY: .uv  ## Check that uv is installed
.uv:
	@uv -V || echo 'Please install uv: https://docs.astral.sh/uv/getting-started/installation/'

.PHONY: .pre-commit  ## Check that pre-commit is installed
.pre-commit: .uv
	@uv run pre-commit -V || uv pip install pre-commit

.PHONY: install  ## Install the package, dependencies, and pre-commit for local development
install: .uv
	uv sync --frozen --group all --all-extras
	uv pip install pre-commit
	uv run pre-commit install --install-hooks

.PHONY: rebuild-lockfiles  ## Rebuild lockfiles from scratch, updating all dependencies
rebuild-lockfiles: .uv
	uv lock --upgrade

.PHONY: format  ## Auto-format python source files
format: .uv
	uv run ruff check --fix $(sources)
	uv run ruff format $(sources)

.PHONY: lint  ## Lint python source files
lint: .uv
	uv run ruff check $(sources)
	uv run ruff format --check $(sources)

.PHONY: codespell  ## Use Codespell to do spellchecking
codespell: .pre-commit
	uv run pre-commit run codespell --all-files

.PHONY: typecheck  ## Perform type-checking
typecheck: .pre-commit
	uv run pre-commit run typecheck --all-files

.PHONY: test-mypy  ## Run the mypy integration tests
test-mypy: .uv
	uv run coverage run -m pytest tests/mypy --test-mypy

.PHONY: test-mypy-update  ## Update the mypy integration tests for the current mypy version
test-mypy-update: .uv
	uv run coverage run -m pytest tests/mypy --test-mypy --update-mypy

.PHONY: test-typechecking-pyright  ## Typechecking integration tests (Pyright)
test-typechecking-pyright: .uv
	uv run bash -c 'cd tests/typechecking && pyright --version && pyright -p pyproject.toml'

.PHONY: test-typechecking-mypy   ## Typechecking integration tests (Mypy). Not to be confused with `test-mypy`.
test-typechecking-mypy: .uv
	uv run bash -c 'cd tests/typechecking && mypy --version && mypy --cache-dir=/dev/null --config-file pyproject.toml .'

.PHONY: test-typechecking-pyrefly  ## Typechecking integration tests (Pyrefly).
test-typechecking-pyrefly: .uv
	uv run bash -c 'cd tests/typechecking && pyrefly --version && pyrefly check'

.PHONY: test  ## Run all tests, skipping the type-checker integration tests
test: .uv
	uv run coverage run -m pytest --durations=10 --parallel-threads $(NUM_THREADS)

.PHONY: benchmark  ## Run all benchmarks
benchmark: .uv
	uv run coverage run -m pytest --durations=10 --benchmark-enable tests/benchmarks

.PHONY: testcov  ## Run tests and generate a coverage report, skipping the type-checker integration tests
testcov: test
	@echo "building coverage html"
	@uv run coverage html
	@echo "building coverage lcov"
	@uv run coverage lcov

.PHONY: test-examples  ## Run only the tests from the documentation
test-examples: .uv
	@echo "running examples"
	@find docs/examples -type f -name '*.py' | xargs -I'{}' sh -c 'uv run python {} >/dev/null 2>&1 || (echo "{} failed")'

.PHONY: test-pydantic-settings  ## Run the pydantic-settings tests with this version of pydantic
test-pydantic-settings: .uv
	git clone https://github.com/pydantic/pydantic-settings.git --single-branch
	bash ./tests/test_pydantic_settings.sh

.PHONY: test-pydantic-extra-types  ## Run the pydantic-extra-types tests with this version of pydantic
test-pydantic-extra-types: .uv
	git clone https://github.com/pydantic/pydantic-extra-types.git --single-branch
	bash ./tests/test_pydantic_extra_types.sh

.PHONY: test-no-docs  # Run all tests except the docs tests
test-no-docs: .uv
	uv run pytest tests --ignore=tests/test_docs.py

.PHONY: all  ## Run the standard set of checks performed in CI
all: lint typecheck codespell testcov

.PHONY: clean  ## Clear local caches and build artifacts
clean:
	rm -rf `find . -name __pycache__`
	rm -f `find . -type f -name '*.py[co]'`
	rm -f `find . -type f -name '*~'`
	rm -f `find . -type f -name '.*~'`
	rm -rf .cache
	rm -rf .pytest_cache
	rm -rf .ruff_cache
	rm -rf htmlcov
	rm -rf *.egg-info
	rm -f .coverage
	rm -f .coverage.*
	rm -rf build
	rm -rf dist
	rm -rf site
	rm -rf docs/_build
	rm -rf docs/.changelog.md docs/.version.md docs/.tmp_schema_mappings.html
	rm -rf fastapi/test.db
	rm -rf coverage.xml

.PHONY: docs  ## Generate the docs
docs:
	uv run mkdocs build --strict

.PHONY: docs-serve
docs-serve: ## Build and serve the documentation, for local preview
	uv run mkdocs serve --strict

.PHONY: help  ## Display this message
help:
	@grep -E \
		'^.PHONY: .*?## .*$$' $(MAKEFILE_LIST) | \
		sort | \
		awk 'BEGIN {FS = ".PHONY: |## "}; {printf "\033[36m%-19s\033[0m %s\n", $$2, $$3}'

.PHONY: update-v1  ## Update V1 namespace
update-v1:
	uv run ./update_v1.sh

=== debian/changelog ===
pydantic (2.12.3-2) unstable; urgency=medium

  * Accept pydantic-core 2.41.5.

 -- Colin Watson <cjwatson@debian.org>  Fri, 07 Nov 2025 12:24:41 +0000

pydantic (2.12.3-1) unstable; urgency=medium

  * New upstream release.
  * Build-depend on python3-pytz rather than python3-tz.

 -- Colin Watson <cjwatson@debian.org>  Sat, 18 Oct 2025 22:28:39 +0100

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pydantic-$1.tar.gz%" \
   https://github.com/pydantic/pydantic/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## pydantic 2.12.4

=== debian/changelog ===
pydantic (2.12.4-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 09 Nov 2025 17:45:55 +0000

=== debian/control ===
Source: pydantic
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
           Colin Watson <cjwatson@debian.org>
Section: python
Testsuite: autopkgtest-pkg-pybuild
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python (>= 6.20241024~),
               dh-sequence-python3,
               cython3,
               pybuild-plugin-pyproject,
               python3-all-dev,
               python3-annotated-types <!nocheck>,
               python3-cloudpickle <!nocheck>,
               python3-dirty-equals <!nocheck>,
               python3-dotenv <!nocheck>,
               python3-email-validator (>= 2.0) <!nocheck>,
               python3-fake-factory <!nocheck>,
               python3-hatch-fancy-pypi-readme,
               python3-jsonschema <!nocheck>,
               python3-packaging (>= 23.2) <!nocheck>,
               python3-pydantic-core (>= 2.41.5),
               python3-pydantic-core (<< 2.41.6),
               python3-pytest (>= 8.2.2) <!nocheck>,
               python3-pytest-benchmark <!nocheck>,
               python3-pytest-mock <!nocheck>,
               python3-pytest-run-parallel <!nocheck>,
               python3-pytz <!nocheck>,
               python3-rich <!nocheck>,
               python3-setuptools,
               python3-typing-extensions (>= 4.14.1) <!nocheck>,
               python3-typing-inspection (>= 0.4.2) <!nocheck>,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/python-team/packages/pydantic
Vcs-Git: https://salsa.debian.org/python-team/packages/pydantic.git
Homepage: https://github.com/samuelcolvin/pydantic
Rules-Requires-Root: no

Package: python3-pydantic
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-email-validator
Breaks: python3-dirty-equals (<< 0.8~),
        python3-djantic (<< 0.7.0-5~),
        python3-maison (<< 2~),
        python3-pydantic-settings (<< 2.5.0),
Description: Data validation and settings management using Python type hinting
 pydantic uses type hinting (PEP 484) and variable annotation (PEP 526) to
 validate that untrusted data takes the desired form. There is also support for
 an extension to dataclasses where the input data is validated.

## pydantic 2.12.5

=== debian/changelog ===
pydantic (2.12.5-2) unstable; urgency=medium

  * Remove `xfail` marker on a PEP 649 related test (closes: #1123166).

 -- Colin Watson <cjwatson@debian.org>  Tue, 16 Dec 2025 23:54:32 +0000

pydantic (2.12.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop "Rules-Requires-Root: no", default as of dpkg-dev 1.22.13.

 -- Colin Watson <cjwatson@debian.org>  Wed, 26 Nov 2025 16:08:04 +0000

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,6 @@
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pydantic
 Vcs-Git: https://salsa.debian.org/python-team/packages/pydantic.git
 Homepage: https://github.com/samuelcolvin/pydantic
-Rules-Requires-Root: no
 
 Package: python3-pydantic
 Architecture: any

## pydantic ai-0.0.8

=== Makefile ===
.DEFAULT_GOAL := all

.PHONY: .uv  # Check that uv is installed
.uv:
	@uv --version || echo 'Please install uv: https://docs.astral.sh/uv/getting-started/installation/'

.PHONY: .pre-commit  # Check that pre-commit is installed
.pre-commit:
	@pre-commit -V || echo 'Please install pre-commit: https://pre-commit.com/'

.PHONY: install  # Install the package, dependencies, and pre-commit for local development
install: .uv .pre-commit
	uv sync --frozen --all-extras --all-packages --group lint --group docs
	pre-commit install --install-hooks

.PHONY: sync  # Update local packages and uv.lock
sync: .uv
	uv sync --all-extras --all-packages --group lint --group docs

.PHONY: format  # Format the code
format:
	uv run ruff format
	uv run ruff check --fix --fix-only

.PHONY: lint  # Lint the code
lint:
	uv run ruff format --check
	uv run ruff check

.PHONY: typecheck-pyright
typecheck-pyright:
	uv run pyright

.PHONY: typecheck-mypy
typecheck-mypy:
	uv run mypy --strict tests/typed_agent.py

.PHONY: typecheck  # Run static type checking
typecheck: typecheck-pyright

.PHONY: typecheck-both  # Run static type checking with both Pyright and Mypy
typecheck-both: typecheck-pyright typecheck-mypy

.PHONY: test  # Run tests and collect coverage data
test:
	uv run coverage run -m pytest
	@uv run coverage report

.PHONY: test-all-python  # Run tests on Python 3.9 to 3.13
test-all-python:
	UV_PROJECT_ENVIRONMENT=.venv39 uv run --python 3.9 --all-extras coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv310 uv run --python 3.10 --all-extras coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv311 uv run --python 3.11 --all-extras coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv312 uv run --python 3.12 --all-extras coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv313 uv run --python 3.13 --all-extras coverage run -p -m pytest
	@uv run coverage combine
	@uv run coverage report

.PHONY: testcov  # Run tests and generate a coverage report
testcov: test
	@echo "building coverage html"
	@uv run coverage html

# `--no-strict` so you can build the docs without insiders packages
.PHONY: docs  # Build the documentation
docs:
	uv run mkdocs build --no-strict

# `--no-strict` so you can build the docs without insiders packages
.PHONY: docs-serve  # Build and serve the documentation
docs-serve:
	uv run mkdocs serve --no-strict

.PHONY: .docs-insiders-install # install insiders packages for docs if necessary
.docs-insiders-install:
ifeq ($(shell uv pip show mkdocs-material | grep -q insiders && echo 'installed'), installed)
	@echo 'insiders packages already installed'
else ifeq ($(PPPR_TOKEN),)
	@echo "Error: PPPR_TOKEN is not set, can't install insiders packages"
	@exit 1
else
	@echo 'installing insiders packages...'
	@uv pip install -U \
		--extra-index-url https://pydantic:${PPPR_TOKEN}@pppr.pydantic.dev/simple/ \
		mkdocs-material mkdocstrings-python
endif

.PHONY: docs-insiders  # Build the documentation using insiders packages
docs-insiders: .docs-insiders-install
	uv run --no-sync mkdocs build -f mkdocs.insiders.yml

.PHONY: docs-serve-insiders  # Build and serve the documentation using insiders packages
docs-serve-insiders: .docs-insiders-install
	uv run --no-sync mkdocs serve -f mkdocs.insiders.yml

.PHONY: cf-pages-build  # Install uv, install dependencies and build the docs, used on CloudFlare Pages
cf-pages-build:
	curl -LsSf https://astral.sh/uv/install.sh | sh
	uv python install 3.12
	uv sync --python 3.12 --frozen --group docs
	uv pip install -U \
		--extra-index-url https://pydantic:${PPPR_TOKEN}@pppr.pydantic.dev/simple/ \
		mkdocs-material mkdocstrings-python
	uv pip freeze
	uv run --no-sync mkdocs build -f mkdocs.insiders.yml

.PHONY: all
all: format lint typecheck testcov

## pydantic ai-0.2.3

=== Makefile ===
.DEFAULT_GOAL := all

.PHONY: .uv
.uv: ## Check that uv is installed
	@uv --version || echo 'Please install uv: https://docs.astral.sh/uv/getting-started/installation/'

.PHONY: .pre-commit
.pre-commit: ## Check that pre-commit is installed
	@pre-commit -V || echo 'Please install pre-commit: https://pre-commit.com/'

.PHONY: .deno
.deno: ## Check that deno is installed
	@deno --version > /dev/null 2>&1 || (printf "\033[0;31m✖ Error: deno is not installed, but is needed for mcp-run-python\033[0m\n    Please install deno: https://docs.deno.com/runtime/getting_started/installation/\n" && exit 1)

.PHONY: install
install: .uv .pre-commit .deno ## Install the package, dependencies, and pre-commit for local development
	uv sync --frozen --all-extras --all-packages --group lint --group docs
	pre-commit install --install-hooks

.PHONY: install-all-python
install-all-python: ## Install and synchronize an interpreter for every python version
	UV_PROJECT_ENVIRONMENT=.venv39 uv sync --python 3.9 --frozen --all-extras --all-packages --group lint --group docs
	UV_PROJECT_ENVIRONMENT=.venv310 uv sync --python 3.10 --frozen --all-extras --all-packages --group lint --group docs
	UV_PROJECT_ENVIRONMENT=.venv311 uv sync --python 3.11 --frozen --all-extras --all-packages --group lint --group docs
	UV_PROJECT_ENVIRONMENT=.venv312 uv sync --python 3.12 --frozen --all-extras --all-packages --group lint --group docs
	UV_PROJECT_ENVIRONMENT=.venv313 uv sync --python 3.13 --frozen --all-extras --all-packages --group lint --group docs

.PHONY: sync
sync: .uv ## Update local packages and uv.lock
	uv sync --all-extras --all-packages --group lint --group docs

.PHONY: format
format: ## Format the code
	uv run ruff format
	uv run ruff check --fix --fix-only

.PHONY: lint
lint: ## Lint the code
	uv run ruff format --check
	uv run ruff check

.PHONY: lint-js
lint-js: ## Lint JS and TS code
	cd mcp-run-python && deno task lint-format

.PHONY: typecheck-pyright
typecheck-pyright:
	@# PYRIGHT_PYTHON_IGNORE_WARNINGS avoids the overhead of making a request to github on every invocation
	PYRIGHT_PYTHON_IGNORE_WARNINGS=1 uv run pyright

.PHONY: typecheck-mypy
typecheck-mypy:
	uv run mypy

.PHONY: typecheck
typecheck: typecheck-pyright ## Run static type checking

.PHONY: typecheck-both  ## Run static type checking with both Pyright and Mypy
typecheck-both: typecheck-pyright typecheck-mypy

.PHONY: test
test: ## Run tests and collect coverage data
	uv run coverage run -m pytest
	@uv run coverage report

.PHONY: test-all-python
test-all-python: ## Run tests on Python 3.9 to 3.13
	UV_PROJECT_ENVIRONMENT=.venv39 uv run --python 3.9 --all-extras --all-packages coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv310 uv run --python 3.10 --all-extras --all-packages coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv311 uv run --python 3.11 --all-extras --all-packages coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv312 uv run --python 3.12 --all-extras --all-packages coverage run -p -m pytest
	UV_PROJECT_ENVIRONMENT=.venv313 uv run --python 3.13 --all-extras --all-packages coverage run -p -m pytest
	@uv run coverage combine
	@uv run coverage report

.PHONY: testcov
testcov: test ## Run tests and generate a coverage report
	@echo "building coverage html"
	@uv run coverage html

.PHONY: test-mrp
test-mrp: ## Build and  tests of mcp-run-python
	cd mcp-run-python && deno task build
	uv run --package mcp-run-python pytest mcp-run-python -v

.PHONY: update-examples
update-examples: ## Update documentation examples
	uv run -m pytest --update-examples tests/test_examples.py

.PHONY: update-vcr-tests
update-vcr-tests: ## Update tests using VCR that hit LLM APIs; note you'll need to set API keys as appropriate
	uv run -m pytest --record-mode=rewrite tests

# `--no-strict` so you can build the docs without insiders packages
.PHONY: docs
docs: ## Build the documentation
	uv run mkdocs build --no-strict

# `--no-strict` so you can build the docs without insiders packages
.PHONY: docs-serve
docs-serve: ## Build and serve the documentation
	uv run mkdocs serve --no-strict

.PHONY: .docs-insiders-install
.docs-insiders-install: ## Install insiders packages for docs if necessary
ifeq ($(shell uv pip show mkdocs-material | grep -q insiders && echo 'installed'), installed)
	@echo 'insiders packages already installed'
else ifeq ($(PPPR_TOKEN),)
	@echo "Error: PPPR_TOKEN is not set, can't install insiders packages"
	@exit 1
else
	@echo 'installing insiders packages...'
	@uv pip install --reinstall --no-deps \
		--extra-index-url https://pydantic:${PPPR_TOKEN}@pppr.pydantic.dev/simple/ \
		mkdocs-material mkdocstrings-python
endif

.PHONY: docs-insiders
docs-insiders: .docs-insiders-install ## Build the documentation using insiders packages
	uv run --no-sync mkdocs build -f mkdocs.insiders.yml

.PHONY: docs-serve-insiders
docs-serve-insiders: .docs-insiders-install ## Build and serve the documentation using insiders packages
	uv run --no-sync mkdocs serve -f mkdocs.insiders.yml

.PHONY: cf-pages-build
cf-pages-build: ## Install uv, install dependencies and build the docs, used on CloudFlare Pages
	curl -LsSf https://astral.sh/uv/install.sh | sh
	uv python install 3.12
	uv sync --python 3.12 --frozen --group docs
	uv pip install --reinstall --no-deps \
		--extra-index-url https://pydantic:${PPPR_TOKEN}@pppr.pydantic.dev/simple/ \
		mkdocs-material mkdocstrings-python
	uv pip freeze
	uv run --no-sync mkdocs build -f mkdocs.insiders.yml

.PHONY: all
all: format lint typecheck testcov ## Run code formatting, linting, static type checks, and tests with coverage report generation

.PHONY: help
help: ## Show this help (usage: make help)
	@echo "Usage: make [recipe]"
	@echo "Recipes:"
	@awk '/^[a-zA-Z0-9_-]+:.*?##/ { \
		helpMessage = match($$0, /## (.*)/); \
		if (helpMessage) { \
			recipe = $$1; \
			sub(/:/, "", recipe); \
			printf "  \033[36m%-20s\033[0m %s\n", recipe, substr($$0, RSTART + 3, RLENGTH); \
		} \
	}' $(MAKEFILE_LIST)

## pydantic ai-1.0.0

=== Makefile ===
--- 
+++ 
@@ -8,18 +8,13 @@
 .pre-commit: ## Check that pre-commit is installed
 	@pre-commit -V || echo 'Please install pre-commit: https://pre-commit.com/'
 
-.PHONY: .deno
-.deno: ## Check that deno is installed
-	@deno --version > /dev/null 2>&1 || (printf "\033[0;31m✖ Error: deno is not installed, but is needed for mcp-run-python\033[0m\n    Please install deno: https://docs.deno.com/runtime/getting_started/installation/\n" && exit 1)
-
 .PHONY: install
-install: .uv .pre-commit .deno ## Install the package, dependencies, and pre-commit for local development
+install: .uv .pre-commit ## Install the package, dependencies, and pre-commit for local development
 	uv sync --frozen --all-extras --all-packages --group lint --group docs
 	pre-commit install --install-hooks
 
 .PHONY: install-all-python
 install-all-python: ## Install and synchronize an interpreter for every python version
-	UV_PROJECT_ENVIRONMENT=.venv39 uv sync --python 3.9 --frozen --all-extras --all-packages --group lint --group docs
 	UV_PROJECT_ENVIRONMENT=.venv310 uv sync --python 3.10 --frozen --all-extras --all-packages --group lint --group docs
 	UV_PROJECT_ENVIRONMENT=.venv311 uv sync --python 3.11 --frozen --all-extras --all-packages --group lint --group docs
 	UV_PROJECT_ENVIRONMENT=.venv312 uv sync --python 3.12 --frozen --all-extras --all-packages --group lint --group docs
@@ -39,10 +34,6 @@
 	uv run ruff format --check
 	uv run ruff check
 
-.PHONY: lint-js
-lint-js: ## Lint JS and TS code
-	cd mcp-run-python && deno task lint-format
-
 .PHONY: typecheck-pyright
 typecheck-pyright:
 	@# PYRIGHT_PYTHON_IGNORE_WARNINGS avoids the overhead of making a request to github on every invocation
@@ -60,12 +51,12 @@
 
 .PHONY: test
 test: ## Run tests and collect coverage data
-	uv run coverage run -m pytest
+	uv run coverage run -m pytest -n auto --dist=loadgroup --durations=20
+	@uv run coverage combine
 	@uv run coverage report
 
 .PHONY: test-all-python
-test-all-python: ## Run tests on Python 3.9 to 3.13
-	UV_PROJECT_ENVIRONMENT=.venv39 uv run --python 3.9 --all-extras --all-packages coverage run -p -m pytest
+test-all-python: ## Run tests on Python 3.10 to 3.13
 	UV_PROJECT_ENVIRONMENT=.venv310 uv run --python 3.10 --all-extras --all-packages coverage run -p -m pytest
 	UV_PROJECT_ENVIRONMENT=.venv311 uv run --python 3.11 --all-extras --all-packages coverage run -p -m pytest
 	UV_PROJECT_ENVIRONMENT=.venv312 uv run --python 3.12 --all-extras --all-packages coverage run -p -m pytest
@@ -74,14 +65,9 @@
 	@uv run coverage report
 
 .PHONY: testcov
-testcov: test ## Run tests and generate a coverage report
+testcov: test ## Run tests and generate an HTML coverage report
 	@echo "building coverage html"
 	@uv run coverage html
-
-.PHONY: test-mrp
-test-mrp: ## Build and  tests of mcp-run-python
-	cd mcp-run-python && deno task build
-	uv run --package mcp-run-python pytest mcp-run-python -v
 
 .PHONY: update-examples
 update-examples: ## Update documentation examples

## pydantic ai-1.0.0b1

=== Makefile ===
--- 
+++ 
@@ -8,8 +8,12 @@
 .pre-commit: ## Check that pre-commit is installed
 	@pre-commit -V || echo 'Please install pre-commit: https://pre-commit.com/'
 
+.PHONY: .deno
+.deno: ## Check that deno is installed
+	@deno --version > /dev/null 2>&1 || (printf "\033[0;31m✖ Error: deno is not installed, but is needed for mcp-run-python\033[0m\n    Please install deno: https://docs.deno.com/runtime/getting_started/installation/\n" && exit 1)
+
 .PHONY: install
-install: .uv .pre-commit ## Install the package, dependencies, and pre-commit for local development
+install: .uv .pre-commit .deno ## Install the package, dependencies, and pre-commit for local development
 	uv sync --frozen --all-extras --all-packages --group lint --group docs
 	pre-commit install --install-hooks
 
@@ -33,6 +37,10 @@
 lint: ## Lint the code
 	uv run ruff format --check
 	uv run ruff check
+
+.PHONY: lint-js
+lint-js: ## Lint JS and TS code
+	cd mcp-run-python && deno task lint-format
 
 .PHONY: typecheck-pyright
 typecheck-pyright:
@@ -68,6 +76,11 @@
 testcov: test ## Run tests and generate an HTML coverage report
 	@echo "building coverage html"
 	@uv run coverage html
+
+.PHONY: test-mrp
+test-mrp: ## Build and tests of mcp-run-python
+	cd mcp-run-python && deno task build
+	uv run --package mcp-run-python pytest mcp-run-python -v
 
 .PHONY: update-examples
 update-examples: ## Update documentation examples

## pydantic ai-1.31.0

=== Makefile ===
--- 
+++ 
@@ -8,12 +8,8 @@
 .pre-commit: ## Check that pre-commit is installed
 	@pre-commit -V || echo 'Please install pre-commit: https://pre-commit.com/'
 
-.PHONY: .deno
-.deno: ## Check that deno is installed
-	@deno --version > /dev/null 2>&1 || (printf "\033[0;31m✖ Error: deno is not installed, but is needed for mcp-run-python\033[0m\n    Please install deno: https://docs.deno.com/runtime/getting_started/installation/\n" && exit 1)
-
 .PHONY: install
-install: .uv .pre-commit .deno ## Install the package, dependencies, and pre-commit for local development
+install: .uv .pre-commit ## Install the package, dependencies, and pre-commit for local development
 	uv sync --frozen --all-extras --all-packages --group lint --group docs
 	pre-commit install --install-hooks
 
@@ -38,14 +34,11 @@
 	uv run ruff format --check
 	uv run ruff check
 
-.PHONY: lint-js
-lint-js: ## Lint JS and TS code
-	cd mcp-run-python && deno task lint-format
-
 .PHONY: typecheck-pyright
 typecheck-pyright:
+	@# To typecheck for a specific version of python, run 'make install-all-python' then set environment variable PYRIGHT_PYTHON=3.10 or similar
 	@# PYRIGHT_PYTHON_IGNORE_WARNINGS avoids the overhead of making a request to github on every invocation
-	PYRIGHT_PYTHON_IGNORE_WARNINGS=1 uv run pyright
+	PYRIGHT_PYTHON_IGNORE_WARNINGS=1 uv run pyright $(if $(PYRIGHT_PYTHON),--pythonversion $(PYRIGHT_PYTHON))
 
 .PHONY: typecheck-mypy
 typecheck-mypy:
@@ -59,16 +52,17 @@
 
 .PHONY: test
 test: ## Run tests and collect coverage data
-	uv run coverage run -m pytest -n auto --dist=loadgroup --durations=20
+	@# To test using a specific version of python, run 'make install-all-python' then set environment variable PYTEST_PYTHON=3.10 or similar
+	COLUMNS=150 $(if $(PYTEST_PYTHON),UV_PROJECT_ENVIRONMENT=.venv$(subst .,,$(PYTEST_PYTHON))) uv run $(if $(PYTEST_PYTHON),--python $(PYTEST_PYTHON)) coverage run -m pytest -n auto --dist=loadgroup --durations=20
 	@uv run coverage combine
 	@uv run coverage report
 
 .PHONY: test-all-python
 test-all-python: ## Run tests on Python 3.10 to 3.13
-	UV_PROJECT_ENVIRONMENT=.venv310 uv run --python 3.10 --all-extras --all-packages coverage run -p -m pytest
-	UV_PROJECT_ENVIRONMENT=.venv311 uv run --python 3.11 --all-extras --all-packages coverage run -p -m pytest
-	UV_PROJECT_ENVIRONMENT=.venv312 uv run --python 3.12 --all-extras --all-packages coverage run -p -m pytest
-	UV_PROJECT_ENVIRONMENT=.venv313 uv run --python 3.13 --all-extras --all-packages coverage run -p -m pytest
+	COLUMNS=150 UV_PROJECT_ENVIRONMENT=.venv310 uv run --python 3.10 --all-extras --all-packages coverage run -p -m pytest
+	COLUMNS=150 UV_PROJECT_ENVIRONMENT=.venv311 uv run --python 3.11 --all-extras --all-packages coverage run -p -m pytest
+	COLUMNS=150 UV_PROJECT_ENVIRONMENT=.venv312 uv run --python 3.12 --all-extras --all-packages coverage run -p -m pytest
+	COLUMNS=150 UV_PROJECT_ENVIRONMENT=.venv313 uv run --python 3.13 --all-extras --all-packages coverage run -p -m pytest
 	@uv run coverage combine
 	@uv run coverage report
 
@@ -76,11 +70,6 @@
 testcov: test ## Run tests and generate an HTML coverage report
 	@echo "building coverage html"
 	@uv run coverage html
-
-.PHONY: test-mrp
-test-mrp: ## Build and tests of mcp-run-python
-	cd mcp-run-python && deno task build
-	uv run --package mcp-run-python pytest mcp-run-python -v
 
 .PHONY: update-examples
 update-examples: ## Update documentation examples

## pydantic core-0.3.1

=== Makefile ===
.DEFAULT_GOAL := all
isort = isort pydantic_core tests generate_self_schema.py
black = black pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py

.PHONY: install
install:
	pip install -U pip wheel pre-commit
	pip install -r tests/requirements.txt
	pip install -r tests/requirements-linting.txt
	pip install -e .
	pre-commit install

.PHONY: install-rust-coverage
install-rust-coverage:
	cargo install rustfilt coverage-prepare
	rustup component add llvm-tools-preview

.PHONY: build-dev
build-dev:
	@rm -f pydantic_core/*.so
	cargo build
	@rm -f target/debug/lib_pydantic_core.d
	@rm -f target/debug/lib_pydantic_core.rlib
	@mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so

.PHONY: build-prod
build-prod:
	@rm -f pydantic_core/*.so
	cargo build --release
	@rm -f target/release/lib_pydantic_core.d
	@rm -f target/release/lib_pydantic_core.rlib
	@mv target/release/lib_pydantic_core.* pydantic_core/_pydantic_core.so

.PHONY: build-coverage
build-coverage:
	pip uninstall -y pydantic_core
	rm -f pydantic_core/*.so
	RUSTFLAGS='-C instrument-coverage -A incomplete_features' cargo build
	@rm -f target/debug/lib_pydantic_core.d
	@rm -f target/debug/lib_pydantic_core.rlib
	mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so

.PHONY: build-wasm
build-wasm:
	@echo 'This requires python 3.10, maturin and emsdk to be installed'
	maturin build --release --target wasm32-unknown-emscripten --out dist -i 3.10
	ls -lh dist

.PHONY: format
format:
	$(isort)
	$(black)
	cargo fmt

.PHONY: lint-python
lint-python:
	flake8 --max-line-length 120 pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
	$(isort) --check-only --df
	$(black) --check --diff

.PHONY: lint-rust
lint-rust:
	cargo fmt --version
	cargo fmt --all -- --check
	cargo clippy --version
	cargo clippy -- -D warnings -A incomplete_features

.PHONY: lint
lint: lint-python lint-rust

.PHONY: pyright
pyright:
	pyright

.PHONY: test
test:
	coverage run -m pytest

.PHONY: py-benchmark
py-benchmark: BRANCH=$(shell git rev-parse --abbrev-ref HEAD)
py-benchmark: build-prod
	@echo "running the \"complete\" python benchmarks, saving to: $(BRANCH)"
	pytest tests/benchmarks/test_complete_benchmark.py --benchmark-enable --benchmark-save=$(BRANCH)

.PHONY: rust-benchmark
rust-benchmark:
	cargo rust-bench

.PHONY: testcov
testcov: build-coverage test
	@rm -rf htmlcov
	@mkdir -p htmlcov
	coverage html -d htmlcov/python
	coverage-prepare html pydantic_core/*.so

.PHONY: all
all: format build-dev lint test

.PHONY: flame
flame:
	@rm -rf perf.data*
	@rm -rf flame
	@mkdir -p flame
	perf record -g profiling/dict_model.py
	perf script --max-stack 20 | stackcollapse-perf.pl | flamegraph.pl > flame/python.svg
	perf script --max-stack 20 | stackcollapse-perf.pl > flame/python.txt
	@rm perf.data
	JSON=1 perf record -g profiling/dict_model.py
	perf script --max-stack 20 | stackcollapse-perf.pl | flamegraph.pl > flame/json.svg
	perf script --max-stack 20 | stackcollapse-perf.pl > flame/json.txt
	@rm perf.data

.PHONY: clean
clean:
	rm -rf `find . -name __pycache__`
	rm -f `find . -type f -name '*.py[co]' `
	rm -f `find . -type f -name '*~' `
	rm -f `find . -type f -name '.*~' `
	rm -rf src/self_schema.py
	rm -rf .cache
	rm -rf flame
	rm -rf htmlcov
	rm -rf .pytest_cache
	rm -rf *.egg-info
	rm -f .coverage
	rm -f .coverage.*
	rm -rf build
	rm -rf perf.data*
	rm -rf pydantic_core/*.so

## pydantic core-0.5.3

=== tests/requirements.txt ===
coverage==6.4.1
dirty-equals==0.4
hypothesis==6.48.1
pytest==7.1.2
pytest-benchmark==3.4.1
pytest-mock==3.8.1
pytest-sugar==0.9.4
pytest-timeout==2.1.0
pydantic==1.9.1;python_version>="3.8"
pytz==2022.1

## pydantic core-0.7.1

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 	cargo fmt --version
 	cargo fmt --all -- --check
 	cargo clippy --version
-	cargo clippy -- -D warnings -A incomplete_features
+	cargo clippy -- -D warnings -A incomplete_features -W clippy::dbg_macro -W clippy::print_stdout
 
 .PHONY: lint
 lint: lint-python lint-rust

=== tests/requirements.txt ===
coverage==6.4.1
dirty-equals==0.4
hypothesis==6.56.4
pytest==7.1.2
pytest-benchmark==3.4.1
pytest-mock==3.8.1
pytest-pretty==0.0.1
pytest-timeout==2.1.0
pydantic==1.9.1;python_version>="3.8"
pytz==2022.1

## pydantic core-0.8.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 .DEFAULT_GOAL := all
 isort = isort pydantic_core tests generate_self_schema.py
 black = black pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+ruff = ruff pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
 
 .PHONY: install
 install:
@@ -50,11 +51,12 @@
 format:
 	$(isort)
 	$(black)
+	$(ruff) --fix --exit-zero
 	cargo fmt
 
 .PHONY: lint-python
 lint-python:
-	flake8 --max-line-length 120 pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+	$(ruff)
 	$(isort) --check-only --df
 	$(black) --check --diff

## pydantic core-0.9.0

=== tests/requirements.txt ===
coverage==7.0.5
dirty-equals==0.5.0
hypothesis==6.63.0
pytest==7.2.1
pytest-speed==0.3.5
pytest-mock==3.10.0
pytest-pretty==1.0.1
pytest-timeout==2.1.0
pydantic==1.10.4;python_version>="3.8"
pytz==2022.7.1

## pydantic core-0.16.0

=== Makefile ===
--- 
+++ 
@@ -76,7 +76,7 @@
 
 .PHONY: test
 test:
-	coverage run -m pytest
+	pytest
 
 .PHONY: py-benchmark
 py-benchmark: BRANCH=$(shell git rev-parse --abbrev-ref HEAD)

## pydantic core-0.17.1

=== Makefile ===
--- 
+++ 
@@ -89,9 +89,11 @@
 	cargo rust-bench
 
 .PHONY: testcov
-testcov: build-coverage test
+testcov: build-coverage
 	@rm -rf htmlcov
 	@mkdir -p htmlcov
+	coverage run -m pytest
+	coverage report
 	coverage html -d htmlcov/python
 	coverage-prepare html pydantic_core/*.so

## pydantic core-0.18.1

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,4 @@
 .DEFAULT_GOAL := all
-isort = isort pydantic_core tests generate_self_schema.py
 black = black pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
 ruff = ruff pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
 
@@ -49,7 +48,6 @@
 
 .PHONY: format
 format:
-	$(isort)
 	$(black)
 	$(ruff) --fix --exit-zero
 	cargo fmt
@@ -57,7 +55,6 @@
 .PHONY: lint-python
 lint-python:
 	$(ruff)
-	$(isort) --check-only --df
 	$(black) --check --diff
 
 .PHONY: lint-rust

## pydantic core-0.33.0

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 .PHONY: build-dev
 build-dev:
 	@rm -f pydantic_core/*.so
-	cargo build
+	cargo build --features extension-module
 	@rm -f target/debug/lib_pydantic_core.d
 	@rm -f target/debug/lib_pydantic_core.rlib
 	@mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so
@@ -26,7 +26,7 @@
 .PHONY: build-prod
 build-prod:
 	@rm -f pydantic_core/*.so
-	cargo build --release
+	cargo build --release --features extension-module
 	@rm -f target/release/lib_pydantic_core.d
 	@rm -f target/release/lib_pydantic_core.rlib
 	@mv target/release/lib_pydantic_core.* pydantic_core/_pydantic_core.so
@@ -35,15 +35,15 @@
 build-coverage:
 	pip uninstall -y pydantic_core
 	rm -f pydantic_core/*.so
-	RUSTFLAGS='-C instrument-coverage -A incomplete_features' cargo build
+	RUSTFLAGS='-C instrument-coverage -A incomplete_features' cargo build --features extension-module
 	@rm -f target/debug/lib_pydantic_core.d
 	@rm -f target/debug/lib_pydantic_core.rlib
 	mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so
 
 .PHONY: build-wasm
 build-wasm:
-	@echo 'This requires python 3.10, maturin and emsdk to be installed'
-	maturin build --release --target wasm32-unknown-emscripten --out dist -i 3.10
+	@echo 'This requires python 3.11, maturin and emsdk to be installed'
+	maturin build --release --target wasm32-unknown-emscripten --out dist -i 3.11
 	ls -lh dist
 
 .PHONY: format
@@ -56,13 +56,14 @@
 lint-python:
 	$(ruff)
 	$(black) --check --diff
+	griffe dump -f -d google -LWARNING -o/dev/null pydantic_core
 
 .PHONY: lint-rust
 lint-rust:
 	cargo fmt --version
 	cargo fmt --all -- --check
 	cargo clippy --version
-	cargo clippy -- -D warnings -A incomplete_features -W clippy::dbg_macro -W clippy::print_stdout
+	cargo clippy --tests -- -D warnings -A incomplete_features -W clippy::dbg_macro -W clippy::print_stdout
 
 .PHONY: lint
 lint: lint-python lint-rust
@@ -81,9 +82,6 @@
 	@echo "running the \"complete\" python benchmarks, saving to: $(BRANCH)"
 	pytest tests/benchmarks/test_complete_benchmark.py --benchmark-enable --benchmark-save=$(BRANCH)
 
-.PHONY: rust-benchmark
-rust-benchmark:
-	cargo rust-bench
 
 .PHONY: testcov
 testcov: build-coverage

## pydantic core-0.40.0

=== Makefile ===
--- 
+++ 
@@ -76,13 +76,6 @@
 test:
 	pytest
 
-.PHONY: py-benchmark
-py-benchmark: BRANCH=$(shell git rev-parse --abbrev-ref HEAD)
-py-benchmark: build-prod
-	@echo "running the \"complete\" python benchmarks, saving to: $(BRANCH)"
-	pytest tests/benchmarks/test_complete_benchmark.py --benchmark-enable --benchmark-save=$(BRANCH)
-
-
 .PHONY: testcov
 testcov: build-coverage
 	@rm -rf htmlcov

=== tests/requirements.txt ===
coverage==7.2.2
dirty-equals==0.5.0
hypothesis==6.63.0
pytest==7.2.1
pytest-examples==0.0.4
pytest-speed==0.3.5
pytest-mock==3.10.0
pytest-pretty==1.1.1
pytest-timeout==2.1.0
pydantic==1.10.4;python_version>="3.8"
pytz==2022.7.1

## pydantic core-2.0.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 .DEFAULT_GOAL := all
-black = black pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
-ruff = ruff pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+black = black python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+ruff = ruff python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+mypy-stubtest = python -m mypy.stubtest pydantic_core._pydantic_core --allowlist .mypy-stubtest-allowlist
 
 .PHONY: install
 install:
@@ -17,28 +18,21 @@
 
 .PHONY: build-dev
 build-dev:
-	@rm -f pydantic_core/*.so
+	@rm -f python/pydantic_core/*.so
 	cargo build --features extension-module
 	@rm -f target/debug/lib_pydantic_core.d
 	@rm -f target/debug/lib_pydantic_core.rlib
-	@mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so
+	@mv target/debug/lib_pydantic_core.* python/pydantic_core/_pydantic_core.so
 
 .PHONY: build-prod
 build-prod:
-	@rm -f pydantic_core/*.so
-	cargo build --release --features extension-module
-	@rm -f target/release/lib_pydantic_core.d
-	@rm -f target/release/lib_pydantic_core.rlib
-	@mv target/release/lib_pydantic_core.* pydantic_core/_pydantic_core.so
+	@rm -f python/pydantic_core/*.so
+	maturin develop --release
 
 .PHONY: build-coverage
 build-coverage:
-	pip uninstall -y pydantic_core
-	rm -f pydantic_core/*.so
-	RUSTFLAGS='-C instrument-coverage -A incomplete_features' cargo build --features extension-module
-	@rm -f target/debug/lib_pydantic_core.d
-	@rm -f target/debug/lib_pydantic_core.rlib
-	mv target/debug/lib_pydantic_core.* pydantic_core/_pydantic_core.so
+	rm -f python/pydantic_core/*.so
+	maturin develop -- -C instrument-coverage
 
 .PHONY: build-wasm
 build-wasm:
@@ -56,14 +50,42 @@
 lint-python:
 	$(ruff)
 	$(black) --check --diff
-	griffe dump -f -d google -LWARNING -o/dev/null pydantic_core
+	$(mypy-stubtest)
+	griffe dump -f -d google -LWARNING -o/dev/null python/pydantic_core
 
 .PHONY: lint-rust
 lint-rust:
 	cargo fmt --version
 	cargo fmt --all -- --check
 	cargo clippy --version
-	cargo clippy --tests -- -D warnings -A incomplete_features -W clippy::dbg_macro -W clippy::print_stdout
+	cargo clippy --tests -- \
+		-D warnings \
+		-W clippy::pedantic \
+		-W clippy::dbg_macro \
+		-W clippy::print_stdout \
+		-A clippy::cast-possible-truncation \
+		-A clippy::cast-possible-wrap \
+		-A clippy::cast-precision-loss \
+		-A clippy::cast-sign-loss \
+		-A clippy::doc-markdown \
+		-A clippy::float-cmp \
+		-A clippy::fn-params-excessive-bools \
+		-A clippy::if-not-else \
+		-A clippy::manual-let-else \
+		-A clippy::match-bool \
+		-A clippy::match-same-arms \
+		-A clippy::missing-errors-doc \
+		-A clippy::missing-panics-doc \
+		-A clippy::module-name-repetitions \
+		-A clippy::must-use-candidate \
+		-A clippy::needless-pass-by-value \
+		-A clippy::similar-names \
+		-A clippy::single-match-else \
+		-A clippy::struct-excessive-bools \
+		-A clippy::too-many-lines \
+		-A clippy::unnecessary-wraps \
+		-A clippy::unused-self \
+		-A clippy::used-underscore-binding
 
 .PHONY: lint
 lint: lint-python lint-rust
@@ -83,7 +105,7 @@
 	coverage run -m pytest
 	coverage report
 	coverage html -d htmlcov/python
-	coverage-prepare html pydantic_core/*.so
+	coverage-prepare html python/pydantic_core/*.so
 
 .PHONY: all
 all: format build-dev lint test
@@ -118,4 +140,4 @@
 	rm -f .coverage.*
 	rm -rf build
 	rm -rf perf.data*
-	rm -rf pydantic_core/*.so
+	rm -rf python/pydantic_core/*.so

## pydantic core-2.6.1

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,13 @@
 black = black python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
 ruff = ruff python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
 mypy-stubtest = python -m mypy.stubtest pydantic_core._pydantic_core --allowlist .mypy-stubtest-allowlist
+
+# using pip install cargo (via maturin via pip) doesn't get the tty handle
+# so doesn't render color without some help
+export CARGO_TERM_COLOR=$(shell (test -t 0 && echo "always") || echo "auto")
+# maturin develop only makes sense inside a virtual env, is otherwise
+# more or less equivalent to pip install -e just a little nicer
+USE_MATURIN = $(shell [ "$$VIRTUAL_ENV" != "" ] && (which maturin))
 
 .PHONY: install
 install:
@@ -16,23 +23,64 @@
 	cargo install rustfilt coverage-prepare
 	rustup component add llvm-tools-preview
 
+.PHONY: install-pgo
+	rustup component add llvm-tools-preview
+
 .PHONY: build-dev
 build-dev:
 	@rm -f python/pydantic_core/*.so
-	cargo build --features extension-module
-	@rm -f target/debug/lib_pydantic_core.d
-	@rm -f target/debug/lib_pydantic_core.rlib
-	@mv target/debug/lib_pydantic_core.* python/pydantic_core/_pydantic_core.so
+ifneq ($(USE_MATURIN),)
+	maturin develop
+else
+	pip install -v -e . --config-settings=build-args='--profile dev'
+endif
 
 .PHONY: build-prod
 build-prod:
 	@rm -f python/pydantic_core/*.so
+ifneq ($(USE_MATURIN),)
 	maturin develop --release
+else
+	pip install -v -e .
+endif
+
+.PHONY: build-profiling
+build-profiling:
+	@rm -f python/pydantic_core/*.so
+ifneq ($(USE_MATURIN),)
+	CARGO_PROFILE_RELEASE_STRIP=false CARGO_PROFILE_RELEASE_DEBUG=true maturin develop --release
+else
+	CARGO_PROFILE_RELEASE_STRIP=false CARGO_PROFILE_RELEASE_DEBUG=true pip install -v -e .
+endif
 
 .PHONY: build-coverage
 build-coverage:
-	rm -f python/pydantic_core/*.so
-	maturin develop -- -C instrument-coverage
+	@rm -f python/pydantic_core/*.so
+ifneq ($(USE_MATURIN),)
+	RUSTFLAGS='-C instrument-coverage' maturin develop --release
+else
+	RUSTFLAGS='-C instrument-coverage' pip install -v -e .
+endif
+
+.PHONY: build-pgo
+build-pgo:
+	@rm -f python/pydantic_core/*.so
+	$(eval PROFDATA := $(shell mktemp -d))
+ifneq ($(USE_MATURIN),)
+	RUSTFLAGS='-Cprofile-generate=$(PROFDATA)' maturin develop --release
+else
+	RUSTFLAGS='-Cprofile-generate=$(PROFDATA)' pip install -v -e .
+endif
+	pytest tests/benchmarks
+	$(eval LLVM_PROFDATA := $(shell rustup run stable bash -c 'echo $$RUSTUP_HOME/toolchains/$$RUSTUP_TOOLCHAIN/lib/rustlib/$$(rustc -Vv | grep host | cut -d " " -f 2)/bin/llvm-profdata'))
+	$(LLVM_PROFDATA) merge -o $(PROFDATA)/merged.profdata $(PROFDATA)
+ifneq ($(USE_MATURIN),)
+	RUSTFLAGS='-Cprofile-use=$(PROFDATA)/merged.profdata' maturin develop --release
+else
+	RUSTFLAGS='-Cprofile-use=$(PROFDATA)/merged.profdata' pip install -v -e .
+endif
+	@rm -rf $(PROFDATA)
+
 
 .PHONY: build-wasm
 build-wasm:

=== tests/requirements.txt ===
coverage==7.2.7
dirty-equals==0.6.0
hypothesis==6.79.4
# pandas doesn't offer prebuilt wheels for all versions and platforms we test in CI e.g. aarch64 musllinux
pandas==2.0.3; python_version >= "3.9" and python_version < "3.12" and implementation_name == "cpython" and platform_machine == 'x86_64'
pytest==7.4.0
# we run codspeed benchmarks on x86_64 CPython (i.e. native github actions architecture)
pytest-codspeed~=2.1.0; implementation_name == "cpython" and platform_machine == 'x86_64'
pytest-examples==0.0.10
pytest-speed==0.3.5
pytest-mock==3.11.1
pytest-pretty==1.2.0
pytest-timeout==2.1.0
pytz==2023.3
# numpy doesn't offer prebuilt wheels for all versions and platforms we test in CI e.g. aarch64 musllinux
numpy==1.25.2; python_version >= "3.9" and python_version < "3.12" and implementation_name == "cpython" and platform_machine == 'x86_64'

## pydantic core-2.14.6

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 .DEFAULT_GOAL := all
-black = black python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
-ruff = ruff python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+sources = python/pydantic_core tests generate_self_schema.py wasm-preview/run_tests.py
+
 mypy-stubtest = python -m mypy.stubtest pydantic_core._pydantic_core --allowlist .mypy-stubtest-allowlist
 
 # using pip install cargo (via maturin via pip) doesn't get the tty handle
@@ -90,14 +90,14 @@
 
 .PHONY: format
 format:
-	$(black)
-	$(ruff) --fix --exit-zero
+	ruff --fix $(sources)
+	ruff format $(sources)
 	cargo fmt
 
 .PHONY: lint-python
 lint-python:
-	$(ruff)
-	$(black) --check --diff
+	ruff $(sources)
+	ruff format --check $(sources)
 	$(mypy-stubtest)
 	griffe dump -f -d google -LWARNING -o/dev/null python/pydantic_core
 
@@ -109,8 +109,6 @@
 	cargo clippy --tests -- \
 		-D warnings \
 		-W clippy::pedantic \
-		-W clippy::dbg_macro \
-		-W clippy::print_stdout \
 		-A clippy::cast-possible-truncation \
 		-A clippy::cast-possible-wrap \
 		-A clippy::cast-precision-loss \

=== tests/requirements.txt ===
coverage==7.2.7
dirty-equals==0.6.0
hypothesis==6.79.4
# pandas doesn't offer prebuilt wheels for all versions and platforms we test in CI e.g. aarch64 musllinux
pandas==2.0.3; python_version >= "3.9" and python_version < "3.12" and implementation_name == "cpython" and platform_machine == 'x86_64'
pytest==7.4.3
# we run codspeed benchmarks on x86_64 CPython (i.e. native github actions architecture)
pytest-codspeed~=2.2.0; implementation_name == "cpython" and platform_machine == 'x86_64'
# pytest-examples currently depends on aiohttp via black; we don't want to build
# it on platforms like aarch64 musllinux in CI
pytest-examples==0.0.10; implementation_name == "cpython" and platform_machine == 'x86_64'
pytest-speed==0.3.5
pytest-mock==3.11.1
pytest-pretty==1.2.0
pytest-timeout==2.2.0
pytz==2023.3.post1
# numpy doesn't offer prebuilt wheels for all versions and platforms we test in CI e.g. aarch64 musllinux
numpy==1.25.2; python_version >= "3.9" and python_version < "3.12" and implementation_name == "cpython" and platform_machine == 'x86_64'
exceptiongroup==1.1; python_version < "3.11"
